unit UQuadrat;

INTERFACE

uses
  MStiftUndCo;
type
  vQuadrat=^kQuadrat;
  kQuadrat=object
    zHPosition,zVPosition,zGroesse: zahl;
    zHStift:vStift;

    procedure IQuadrat(h,v,groesse: zahl);
    procedure GibFrei;
    procedure Zeichne;
    procedure nachOben;
    procedure nachUnten;
    procedure nachRechts;
    procedure nachLinks;
    procedure verschiebe(dh,dv:zahl);

  end;

IMPLEMENTATION

procedure kQuadrat.Zeichne;
begin
  zHStift^.hoch;
  zHStift^.bewegeBis(zHposition,zVposition);
  zHStift^.runter;
  zhStift^.zeichneRechteck(zGroesse,zGroesse);
end;

procedure kQuadrat.IQuadrat(h,v,groesse:zahl);
begin
  zHPosition:=h;
  zVPosition:=v;
  zGroesse:=groesse;
  New(zhStift);
  zhStift^.init;
  zhStift^.bewegeBis(h,v);
  zeichne;
end;

procedure kQuadrat.gibFrei;
begin
  zHStift^.gibFrei;
  dispose(zHstift);
end;

procedure kQuadrat.verschiebe(dh,dv:zahl);
begin
  zHstift^.radiere;
  zeichne;
  zHposition:=(zHposition+dh);
  zVposition:=(zVposition+dv);
  zHstift^.normal;
  zeichne;
end;

procedure kQuadrat.nachOben;
begin
  zHstift^.radiere;
  zeichne;
  zVposition:=zVposition-zGroesse;
  zHstift^.normal;
  zeichne;
end;

procedure kQuadrat.nachUnten;
begin
  zHstift^.radiere;
  zeichne;
  zVposition:=zVposition+zGroesse;
  zHstift^.normal;
  zeichne;
end;

procedure kQuadrat.nachRechts;
begin
  zHstift^.radiere;
  zeichne;
  zHposition:=zHposition+zGroesse;
  zHstift^.normal;
  zeichne;
end;

procedure kQuadrat.nachLinks;
begin
  zHstift^.radiere;
  zeichne;
  zHposition:=zHposition-zGroesse;
  zHstift^.normal;
  zeichne;
end;

end.