program test_uQuadrat;
uses
  vQuadrat,mStiftundCo,graph;
const
  groesse=20;
var
  quadrat: array[1..13] of vQuad;
  schirm: vBildschirm;
  board: vTastatur;
  maus: vMaus;
  ende: boolean;
  i,qAnzahl,qAktiv: word;

begin
  new(schirm);
  schirm^.init;
  new(board);
  board^.init;
  setcolor(blue);
  i:=(groesse-1);
  repeat
    line(i,0,i,480);
    inc(i,groesse);
  until i>640;
  i:=(groesse-2);
  repeat
    line(0,i,640,i);
    inc(i,groesse);
  until i>480;
  new(Maus);
  maus^.init;
  randomize;
  new(quadrat[1]);
  quadrat[1]^.init('uuuu',1,groesse,2*groesse,1*groesse,'b',0); {I}
  new(quadrat[2]);
  quadrat[2]^.init('uurr',1,groesse,4*groesse,1*groesse,'b',0); {V}
  new(quadrat[3]);
  quadrat[3]^.init('urro',1,groesse,8*groesse,1*groesse,'b',0); {U}
  new(quadrat[4]);
  quadrat[4]^.init('ruur',1,groesse,12*groesse,1*groesse,'b',0); {Z}
  new(quadrat[5]);
  quadrat[5]^.init('psvo',1,groesse,16*groesse,1*groesse,'b',0); {X}
  new(quadrat[6]);
  quadrat[6]^.init('rrvu',1,groesse,20*groesse,1*groesse,'b',0); {T}
  new(quadrat[7]);
  quadrat[7]^.init('uuur',1,groesse,2*groesse,7*groesse,'r',0); {L}
  new(quadrat[8]);
  quadrat[8]^.init('oror',1,groesse,5*groesse,7*groesse,'b',0); {M}
  new(quadrat[9]);
  quadrat[9]^.init('uruu',1,groesse,9*groesse,7*groesse,'b',0); {S}
  new(quadrat[10]);
  quadrat[10]^.init('rslu',1,groesse,12*groesse,7*groesse,'b',0); {R}
  new(quadrat[11]);
  quadrat[11]^.init('rulu',1,groesse,16*groesse,7*groesse,'b',0); {P}
  new(quadrat[12]);
  quadrat[12]^.init('ulsu',1,groesse,20*groesse,7*groesse,'b',0); {Y}
  qAnzahl:=12;
  qAktiv:=12;
  quadrat[qAktiv]^.aktiviere;

  repeat
    if maus^.istGedrueckt then
    begin
      for i:=1 to qAnzahl do
      if quadrat[i]^.wurdeGetroffen(round(maus^.hPosition),round(maus^.vPosition),'b') then
      begin
        quadrat[qAktiv]^.deaktiviere;
        qAktiv:=i;
        quadrat[qAktiv]^.aktiviere;
      end;
      repeat
      until not(maus^.istGedrueckt);
    end;
    if board^.wurdeGedrueckt then
    case board^.zeichen of
      pfeilLinks: Quadrat[qAktiv]^.bewege('l','b');
      pfeilRechts: Quadrat[qAktiv]^.bewege('r','b');
      pfeilOben: Quadrat[qAktiv]^.bewege('o','b');
      pfeilUnten: Quadrat[qAktiv]^.bewege('u','b');
      's': quadrat[qaktiv]^.spiegle;
      'd': quadrat[qaktiv]^.drehe;
      escape: ende:=true;
    end;
  until ende;

  for i:= 1 to qAnzahl do
  begin
    quadrat[i]^.ende('b');
    dispose(quadrat[i]);
  end;
  board^.gibFrei;
  dispose(board);
  maus^.gibfrei;
  dispose(maus);
  Cleardevice; closegraph; RestoreCrtMode; { Schirm^.gibFrei }
  dispose(schirm);
end.